class Transaction;

  operand_t operand_a;
  operand_t operand_b;
  opcode_t opcode;
  address_t write_pointer;

  function new();
    opcode = ZERO;
    operand_a = 0;
    operand_b = 0;
    write_pointer = 0;
  endfunction

  function void randomize_transaction();
    // A later lab will replace this function with SystemVerilog
    // constrained random values
    //
    // The static temp variable is required in order to write to fixed
    // addresses of 0, 1 and 2.  This will be replaced with randomized
    // write_pointer values in a later lab
    //
    static int temp = 0;
    this.operand_a     = $urandom_range(0, 30) - 15;       // between -15 and 15
    this.operand_b     = $urandom_range(0, 15);            // between 0 and 15
    this.opcode        = opcode_t'($urandom_range(0, 7));  // between 0 and 7, cast to opcode_t type
    this.write_pointer = temp++;
  endfunction: randomize_transaction

  function void print_transaction();
    $display("Write to register location %2d: opcode = %0d (%5s) operand_a =%3d  operand_b =%3d", 
 	     this.write_pointer, this.opcode, this.opcode.name(), this.operand_a, this.operand_b);
  endfunction

endclass: Transaction

