/***********************************************************************
 * A top-level module to connect two processors, using an interface.
 *
 **********************************************************************/

module proc_top (input logic clk, rst);
  timeunit 1ns; timeprecision 1ns;

  proc_ifc io (.clk(clk), .rst(rst));   //instantiate the interface

  proc1 p1 (.io(io.bus_master)); // connect using interface master modport
  proc2 p2 (.io(io.bus_slave));  // connect using interface slave modport

endmodule: proc_top
