
class Generator extends Component;

  Transaction trn_h;

  // ***LAB   remove Driver and Scoreboard handles and replace with 
  //          two mailbox handles, gen2drv_h and gen2scb_h
  mailbox #(Transaction) gen2drv_h;
  mailbox #(Transaction) gen2scb_h;

  // ***LAB   remove all mention of drv_h and scb_h 
  function new();
    this.trn_h = new();
  endfunction

  task run(int n);
    repeat (n) begin
      if (!trn_h.randomize()) $fatal("Randomiztion failure");
      this.send(trn_h);
      trn_h.print_transaction();
    end
  endtask

  // ***LAB   replace calls to Scoreboard and Driver with puts of 
  //          cloned transaction in the two mailboxes. 
  task send(Transaction trn_h);
     gen2scb_h.put(trn_h.clone());     
     gen2drv_h.put(trn_h.clone());     

  endtask

endclass : Generator

